// To parse this JSON data, do
//
//     final speiderResult = speiderResultFromJson(jsonString);

import 'dart:convert';

SpeiderResult speiderResultFromJson(String str) => SpeiderResult.fromJson(json.decode(str));

String speiderResultToJson(SpeiderResult data) => json.encode(data.toJson());

class SpeiderResult {
  SpeiderResult({
    this.goScroll,
    this.totalNum,
    this.list,
    this.pageId,
  });

  bool goScroll;
  int totalNum;
  List<ListElement> list;
  String pageId;

  factory SpeiderResult.fromJson(Map<String, dynamic> json) => SpeiderResult(
    goScroll: json["goScroll"],
    totalNum: json["totalNum"],
    list: List<ListElement>.from(json["list"].map((x) => ListElement.fromJson(x))),
    pageId: json["pageId"],
  );

  Map<String, dynamic> toJson() => {
    "goScroll": goScroll,
    "totalNum": totalNum,
    "list": List<dynamic>.from(list.map((x) => x.toJson())),
    "pageId": pageId,
  };
}

class ListElement {
  ListElement({
    this.itemId,
    this.remark,
    this.updateTime,
    this.title,
    this.url,
  });

  String itemId;
  Remark remark;
  DateTime updateTime;
  String title;
  String url;

  factory ListElement.fromJson(Map<String, dynamic> json) => ListElement(
    itemId: json["itemId"],
    remark: remarkValues.map[json["remark"]],
    updateTime: DateTime.parse(json["updateTime"]),
    title: json["title"],
    url: json["url"],
  );

  Map<String, dynamic> toJson() => {
    "itemId": itemId,
    "remark": remarkValues.reverse[remark],
    "updateTime": updateTime.toIso8601String(),
    "title": title,
    "url": url,
  };
}

enum Remark { EMPTY, REMARK }

final remarkValues = EnumValues({
  "": Remark.EMPTY,
  "楼上内裤链接错了，用这个哈": Remark.REMARK
});

class EnumValues<T> {
  Map<String, T> map;
  Map<T, String> reverseMap;

  EnumValues(this.map);

  Map<T, String> get reverse {
    if (reverseMap == null) {
      reverseMap = map.map((k, v) => new MapEntry(v, k));
    }
    return reverseMap;
  }
}
